if {$::tcl_version>=8.1} {
	load dll10
	set ::dll::AW W
	} \
else {
	load dll02
	set ::dll::AW A
	}
###############################################################################
#	::dll::WIN32_Const id
#
#	returns numeric value for specific named constants
#	UnDecorateSymbolName Flags
#	UNDNAME_COMPLETE                 (0x0000)  // Enable full undecoration
#	UNDNAME_NO_LEADING_UNDERSCORES   (0x0001)  // Remove leading underscores from MS extended keywords
#	UNDNAME_NO_MS_KEYWORDS           (0x0002)  // Disable expansion of MS extended keywords
#	UNDNAME_NO_FUNCTION_RETURNS      (0x0004)  // Disable expansion of return type for primary declaration
#	UNDNAME_NO_ALLOCATION_MODEL      (0x0008)  // Disable expansion of the declaration model
#	UNDNAME_NO_ALLOCATION_LANGUAGE   (0x0010)  // Disable expansion of the declaration language specifier
#	UNDNAME_NO_MS_THISTYPE           (0x0020)  // NYI Disable expansion of MS keywords on the 'this' type for primary declaration
#	UNDNAME_NO_CV_THISTYPE           (0x0040)  // NYI Disable expansion of CV modifiers on the 'this' type for primary declaration
#	UNDNAME_NO_THISTYPE              (0x0060)  // Disable all modifiers on the 'this' type
#	UNDNAME_NO_ACCESS_SPECIFIERS     (0x0080)  // Disable expansion of access specifiers for members
#	UNDNAME_NO_THROW_SIGNATURES      (0x0100)  // Disable expansion of 'throw-signatures' for functions and pointers to functions
#	UNDNAME_NO_MEMBER_TYPE           (0x0200)  // Disable expansion of 'static' or 'virtual'ness of members
#	UNDNAME_NO_RETURN_UDT_MODEL      (0x0400)  // Disable expansion of MS model for UDT returns
#	UNDNAME_32_BIT_DECODE            (0x0800)  // Undecorate 32-bit decorated names
#	UNDNAME_NAME_ONLY                (0x1000)  // Crack only the name for primary declaration;
#  	                                         //  return just [scope::]name.  Does expand template params
#	UNDNAME_NO_ARGUMENTS             (0x2000)  // Don't undecorate arguments to function
#	UNDNAME_NO_SPECIAL_SYMS          (0x4000)  // Don't undecorate special names (v-table, vcall, vector xxx, metatype, etc)
#
proc	::dll::WIN32_Const {args} {
	if {![info exists ::dll::WIN32_Const]} {
		array set ::dll::WIN32_Const {
			UNDNAME_COMPLETE                 0x0000
			UNDNAME_NO_LEADING_UNDERSCORES   0x0001
			UNDNAME_NO_MS_KEYWORDS           0x0002
			UNDNAME_NO_FUNCTION_RETURNS      0x0004
			UNDNAME_NO_ALLOCATION_MODEL      0x0008
			UNDNAME_NO_ALLOCATION_LANGUAGE   0x0010
			UNDNAME_NO_MS_THISTYPE           0x0020
			UNDNAME_NO_CV_THISTYPE           0x0040
			UNDNAME_NO_THISTYPE              0x0060
			UNDNAME_NO_ACCESS_SPECIFIERS     0x0080
			UNDNAME_NO_THROW_SIGNATURES      0x0100
			UNDNAME_NO_MEMBER_TYPE           0x0200
			UNDNAME_NO_RETURN_UDT_MODEL      0x0400
			UNDNAME_32_BIT_DECODE            0x0800
			UNDNAME_NAME_ONLY                0x1000
			UNDNAME_NO_ARGUMENTS             0x2000
			UNDNAME_NO_SPECIAL_SYMS          0x4000
			SWP_NOSIZE          0x0001
			SWP_NOMOVE          0x0002
			SWP_NOZORDER        0x0004
			SWP_NOREDRAW        0x0008
			SWP_NOACTIVATE      0x0010
			SWP_FRAMECHANGED    0x0020
			SWP_SHOWWINDOW      0x0040
			SWP_HIDEWINDOW      0x0080
			SWP_NOCOPYBITS      0x0100
			SWP_NOOWNERZORDER   0x0200
			SWP_NOSENDCHANGING  0x0400
			SWP_DRAWFRAME       0x0020
			SWP_NOREPOSITION    0x0200
			HWND_TOP        	0
			HWND_BOTTOM     	1
			HWND_TOPMOST    	-1
			HWND_NOTOPMOST  	-2
			SW_HIDE             0
			SW_SHOWNORMAL       1
			SW_NORMAL           1
			SW_SHOWMINIMIZED    2
			SW_SHOWMAXIMIZED    3
			SW_MAXIMIZE         3
			SW_SHOWNOACTIVATE   4
			SW_SHOW             5
			SW_MINIMIZE         6
			SW_SHOWMINNOACTIVE  7
			SW_SHOWNA           8
			SW_RESTORE          9
			SW_SHOWDEFAULT      10
			SW_FORCEMINIMIZE    11
			MB_OK                       0x00000000
			MB_OKCANCEL                 0x00000001
			MB_ABORTRETRYIGNORE         0x00000002
			MB_YESNOCANCEL              0x00000003
			MB_YESNO                    0x00000004
			MB_RETRYCANCEL              0x00000005


			MB_ICONHAND                 0x00000010
			MB_ICONQUESTION             0x00000020
			MB_ICONEXCLAMATION          0x00000030
			MB_ICONASTERISK             0x00000040

			MB_ICONINFORMATION          0x00000040
			MB_ICONSTOP                 0x00000010

			MB_DEFBUTTON1               0x00000000
			MB_DEFBUTTON2               0x00000100
			MB_DEFBUTTON3               0x00000200

			MB_APPLMODAL                0x00000000
			MB_SYSTEMMODAL              0x00001000
			MB_TASKMODAL                0x00002000

			MB_NOFOCUS                  0x00008000
			MB_SETFOREGROUND            0x00010000
			MB_DEFAULT_DESKTOP_ONLY     0x00020000


			MB_TYPEMASK                 0x0000000F
			MB_ICONMASK                 0x000000F0
			MB_DEFMASK                  0x00000F00
			MB_MODEMASK                 0x00003000
			MB_MISCMASK                 0x0000C000
			IDOK                1
			IDCANCEL            2
			IDABORT             3
			IDRETRY             4
			IDIGNORE            5
			IDYES               6
			IDNO                7
			}

		if {$::tcl_platform(osVersion) >= 4.00} {
			array set ::dll::WIN32_Const {
				SWP_DEFERERASE      0x2000
				SWP_ASYNCWINDOWPOS  0x4000
				MB_HELP             0x00004000
				MB_USERICON         0x00000080
				MB_ICONWARNING      0x00000030
				MB_ICONERROR        0x00000010
				MB_DEFBUTTON4       0x00000300
				MB_TOPMOST          0x00040000
				MB_RIGHT            0x00080000
				MB_RTLREADING       0x00100000
				IDCLOSE         	8
				IDHELP          	9
				}
			}
		if {$::tcl_platform(os) == "Windows NT"} {
			if {$::tcl_platform(osVersion) >= 4.00} {
				array set ::dll::WIN32_Const {
					MB_SERVICE_NOTIFICATION          0x00200000
					}
				} \
			else {
				array set ::dll::WIN32_Const {
					MB_SERVICE_NOTIFICATION          0x00040000
					}
				}
			} \
		else {
			array set ::dll::WIN32_Const {
				MB_SERVICE_NOTIFICATION_NT3X         0x00040000
				}
			}
		}
	set res 0
	foreach n $args {
		set res [expr {$res | $::dll::WIN32_Const($n)}]
		}
	return [format 0x%8.8x $res]
	}

if 1 {
	::dll::declare kernel32.dll GetLastError GetLastError i
	::dll::declare kernel32.dll SetLastError SetLastError v i
	::dll::declare kernel32.dll OpenProcess OpenProcess i i i i
	::dll::declare kernel32.dll OpenProcess HandleFromPID i {i 0x410} {i 0} i
	::dll::declare kernel32.dll TerminateProcess TerminateProcess i i i
	::dll::declare kernel32.dll CloseHandle CloseHandle i i
	::dll::declare user32.dll	ShowWindow HideWindow i i {i 0}
	::dll::declare user32.dll	ShowWindow RestoreWindow i i {i 9}
	::dll::declare user32.dll	GetWindowThreadProcessId GetWindowThreadProcessId i i *4
	::dll::declare user32.dll	GetWindowThreadProcessId GetWindowThreadId i i {i 0}
	} \
else {
	proc GetLastError {} {
		return [::dll::call kernel32.dll GetLastError i]
		}
	proc SetLastError {i} {
		::dll::call kernel32.dll SetLastError v [list i $i]
		}
	proc HandleFromPID {PID} {
		return [::dll::call kernel32.dll OpenProcess i {i 0x410} {i 0} [list i $PID]]
		}
	proc TerminateProcess {handle exitCode} {
		return [::dll::call kernel32.dll TerminateProcess i [list i $handle] [list i $exitCode]]
		}
	proc CloseHandle {handle} {
		return [::dll::call kernel32.dll CloseHandle i [list i $handle]
		}
	proc HideWindow {handle} {
		return [::dll::call user32.dll ShowWindow i [list i $handle] {i 0}
		}
	proc RestoreWindow {handle} {
		return [::dll::call user32.dll ShowWindow i [list i $handle] {i 9}
		}
	proc GetWindowThreadId {hwnd} {
		return [::dll::call user32.dll GetWindowThreadProcessId i [list i $hwnd] {i 0}]
		}
	proc GetWindowThreadProcessId {hwnd px} {
		upvar $px x
		return [::dll::call user32.dll GetWindowThreadProcessId i [list i $hwnd] [list *4 x]]
		}
	}

proc GetWindowProcessId {hwnd} {
	set tid [GetWindowThreadProcessId $hwnd x]
	if {$tid} {
		binary scan $x i v
		return $v
		} \
	else {
		return 0
		}
	}

proc MessageBox { Message Caption Type } {
   return [::dll::call user32 MessageBox$::dll::AW i {i 0} [list s $Message] [list s $Caption] [list i [expr {$Type|0x1000}]]]
   }

proc TerminateProcessPID {PID exitCode} {
	if {[set r [set h [HandleFromPID $PID]]]} {
		set r [TerminateProcess $h $exitCode]
		CloseHandle $h
		}
	return $r
	}

proc GetWindowText {hWnd} {
	#set r [::dll::call user32.dll GetWindowText$::dll::AW i [list i $hWnd] {*s256 text} {i 255}]
	set r [::dll::call user32.dll GetWindowTextA i [list i $hWnd] {*s256 text} {i 255}]
    binary scan $text a$r str
    set str
	}

proc EnumWindows {} {
	proc EnumWCB {i s} {
		upvar 1 $s L
		lappend L 0x[format %x $i]
		return 1
		}
	::dll::callback cdecl EnumWCB EnumWCB i i s
	set WindowList {}
	::dll::call user32.dll EnumWindows i {@ EnumWCB} {s WindowList}
	rename EnumWCB {}
	::dll::callback delete EnumWCB
	return $WindowList
	}

# returns toplevel window handle corresponding to a PID
proc PID_to_hWnd {pid} {
	foreach h [EnumWindows] {
		if {$pid==[GetWindowProcessID $h]} {
			return $h
			}
		}
	return 0
	}

proc GetTitledWindows {} {
	set r {}
	foreach w [EnumWindows] {
		set t [string trim [GetWindowText $w]]
		if {[string length $t]} {
			lappend r [list $w $t]
			}
		}
	return $r
	}

#find window handle based on class and title
proc FindWindow {class title} {
	return [::dll::call user32.dll FindWindow$::dll::AW i [list s $class] [list s $title]]
	}

#forground
proc GetForegroundWindow {} {
	return [::dll::call user32.dll GetForegroundWindow i]
	}

#force to forground
proc SetForegroundWindow {hWnd} {
	return [::dll::call user32.dll SetForegroundWindow i [list i $hWnd]]
	}

#Set Window Text
proc SetWindowText {hWnd Text} {
	return [::dll::call user32.dll SetWindowText$::dll::AW i [list i $hWnd] [list s $Text]]
	}

#Is it a window
proc IsWindow {hWnd} {
	return [::dll::call user32.dll IsWindow i [list i $hWnd]]
	}

#Is window zoomed
proc IsZoomed {hWnd} {
	return [::dll::call user32.dll IsZoomed i [list i $hWnd]]
	}

#Is window enabled
proc IsWindowEnabled {hWnd} {
	return [::dll::call user32.dll IsWindowEnabled i [list i $hWnd]]
	}

#enable window true/false
proc EnableWindow {hWnd flag} {
	if {$flag} {set flag 1} else {set flag 0}
	return [::dll::call user32.dll EnableWindow i [list i $hWnd] [list i $flag]]
	}

#Is window visible
proc IsWindowVisible {hWnd} {
	return [::dll::call user32.dll IsWindowVisible i [list i $hWnd]]
	}

#Is window iconised
proc IsIconic {hWnd} {
	return [::dll::call user32.dll IsIconic i [list i $hWnd]]
	}

#destroy in current thread
proc DestroyWindow {hWnd} {
	return [::dll::call user32.dll DestroyWindow i [list i $hWnd]]
	}

#PostMessage
proc PostMessage {hWnd Msg {wParam 0} {lParam 0}} {
	return [::dll::call user32.dll PostMessage$::dll::AW i [list i $hWnd] [list i $Msg] [list i $wParam] [list i $lParam]]
	}

#WM_CLOSE
proc Wm_Close {hWnd} {
	PostMessage $hWnd 0x10
	}

if	1 {
	::dll::declare user32.dll SetWindowPos _SetZOrder i i i \
			{i 0} {i 0} {i 0} {i 0} \
			[list i [::dll::WIN32_Const SWP_ASYNCWINDOWPOS SWP_NOACTIVATE SWP_NOMOVE SWP_NOSIZE SWP_SHOWWINDOW]]
	} \
else {
	proc _SetZOrder {hWnd Z} "
		return \[::dll::call user32.dll SetWindowPos i \[list i \$hWnd\] \
			\[list i \$Z\] \
			{i 0} {i 0} {i 0} {i 0} {i [::dll::WIN32_Const SWP_ASYNCWINDOWPOS SWP_NOACTIVATE SWP_NOMOVE SWP_NOSIZE SWP_SHOWWINDOW]}\]
		"
	}

proc SetZOrder {hWnd {Z TOPMOST}} {
	return [_SetZOrder $hWnd [::dll::WIN32_Const HWND_$Z]]
	}

#Force to Top of Z Order
proc ForceTop {hWnd} {
	SetZOrder $hWnd TOPMOST
	}

#iconize
proc CloseWindow {hWnd} {
	return [::dll::call user32.dll CloseWindow i [list i $hWnd]]
	}

#restore
proc OpenIcon {hWnd} {
	return [::dll::call user32.dll OpenIcon i [list i $hWnd]]
	}

#LoadLibrary
proc LoadLibrary {path} {
	return [::dll::call kernel32.dll LoadLibrary$::dll::AW i [list s $path]]
	}

#GetProcAddress
proc GetProcAddress {h name} {
	return [::dll::call kernel32.dll GetProcAddress i [list i $h] [list s $name]]
	}

proc LoadLibraryEx {path hfile flags} {
	return [::dll::call kernel32.dll LoadLibraryEx$::dll::AW i [list s $path] [list i $hfile] [list i $flags]]
	}

#FreeLibrary
proc FreeLibrary {hLibModule} {
	return [::dll::call kernel32.dll FreeLibrary i [list i $hLibModule]]
	}

#Get resources from an exe or dll
proc EnumModuleResources {path} {
	array set RT {
		1	RT_CURSOR
		2	RT_BITMAP
		3	RT_ICON
		4	RT_MENU
		5	RT_DIALOG
		6	RT_STRING
		7	RT_FONTDIR
		8	RT_FONT
		9	RT_ACCELERATOR
		10	RT_RCDATA
		11	RT_MESSAGETABLE
		12	RT_GROUP_CURSOR
		14	RT_GROUP_ICON
		16	RT_VERSION
		17	RT_DLGINCLUDE
		19	RT_PLUGPLAY
		20	RT_VXD}
	proc EnumLangs {hModule lpType lpName wLang lParam} {
		upvar 1 $lParam L
		lappend L [list 0x[format %x [expr {0xffff&$wLang}]] 0x[format %x [::dll::call kernel32.dll FindResourceEx$::dll::AW i \
			[list i $hModule] [list i $lpType] [list i $lpName] [list i $wLang]]]]
		return 1
		}
	::dll::callback cdecl EnumLangs EnumLangs i i i i i s
	proc EnumResourceLanguages {hModule lpType lpName} {
		set List {}
		::dll::call kernel32.dll EnumResourceLanguages$::dll::AW i [list i $hModule] [list i $lpType] [list i $lpName] {@ EnumLangs} {s List}
		return [luniq $List]
		}
	proc EnumNames {hModule lpType lpName lParam} {
		upvar 1 $lParam L
		set N [EnumResourceLanguages $hModule $lpType $lpName]
		if {$lpName&0xffff0000} {
			lappend L [list [list 0x[format %X $lpName] [::dll::int2str $lpName]] $N]
			} \
		else {
			lappend L [list 0x[format %X $lpName] $N]
			}
		return 1
		}
	::dll::callback cdecl EnumNames EnumNames i i i i s
	proc EnumResourceNames {hModule lpType} {
		set List {}
		::dll::call kernel32.dll EnumResourceNames$::dll::AW i [list i $hModule] [list i $lpType] {@ EnumNames} {s List}
		return [luniq $List]
		}
	proc EnumTypes {hModule lpszType lParam} {
		upvar 1 $lParam L RT rt
		set N [EnumResourceNames $hModule $lpszType]
		if {$lpszType&0xffff0000} {
			lappend L [list [list 0x[format %X $lpszType] [::dll::int2str $lpszType]] $N]
			} \
		elseif {[info exists rt($lpszType)]} {
			lappend L [list [list 0x[format %X $lpszType] $rt($lpszType)] $N]
			} \
		else {
			lappend L [list 0x[format %X $lpszType] $N]
			}
		return 1
		}
	::dll::callback cdecl EnumTypes EnumTypes i i i s
	set hModule [LoadLibraryEx $path 0 3]
	if {!$hModule} {
		error "Can't LoadLibrary '$path'"
		}
	set List {}
	::dll::call kernel32.dll EnumResourceTypes$::dll::AW i [list i $hModule] {@ EnumTypes} {s List}
	FreeLibrary $hModule
	rename EnumLangs {}
	::dll::callback delete EnumLangs
	rename EnumNames {}
	::dll::callback delete EnumNames
	rename EnumTypes {}
	::dll::callback delete EnumTypes
	return [luniq $List]
	}
proc p3LevelList {dump hdr L {flush 0}} {
	if {"$hdr"!={}} {
		puts $dump $hdr; if {$flush} {flush $dump}
		}
	foreach a $L {
		puts $dump [lindex $a 0]; if {$flush} {flush $dump}
		foreach b [lindex $a 1] {
			puts $dump "    [lindex $b 0]"; if {$flush} {flush $dump}
			foreach c [lindex $b 1] {
				puts $dump "        $c"; if {$flush} {flush $dump}
				}
			}
		}
	}

################################
#	sets TCP_NODELAY flag for
#	socket		sock
#	direction	d either w or r
proc SetNodelay {sock d v} {
	switch $d {
		w	{set d 4}
		r	{set d 2}
		default {error "SetNodelay: bad direction"}
		}
	set C [::dll::call tcl80 Tcl_GetChannel i \
		[list i [::dll::get_interp]] [list s $sock] {i 0}]
	if {[::dll::call tcl80 Tcl_GetChannelHandle i \
		[list i $C] [list i $d] {*4 H}]} {
		error "SetNodelay: can't get handle"
		}
	binary scan $H i HV

	if {$v} {
		set v "\1\0\0\0"
		} \
	else {
		set v "\0\0\0\0"
		}
	return [::dll::call wsock32 setsockopt i \
		[list i $HV] \
		{i 6} {i 1} {*4 v} {i 4}]
	}

proc UnDecorateSymbolName {DN {F 0}} {
	set res [::dll::call imagehlp UnDecorateSymbolName i \
		[list s $DN] [list *s4096 UDN] {i 4095} [list i $F]]
	if {!$res} {
		error "UnDecorateSymbolName: error code [GetLastError]"
		}
	return $UDN
	}
