#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include "tcl.h"
#include "generate.h"

void	DynBytes_Extend( pDynBytes_t pBytes, size_t n )
{
	if((n+=pBytes->mempos)>pBytes->memlen){
		pBytes->memlen += pBytes->memlen;
		if(pBytes->memlen<n) pBytes->memlen = n;
		pBytes->mem = ckrealloc(pBytes->mem,pBytes->memlen);
		}
}

void	DynBytes_Init(pDynBytes_t pBytes)
{
	pBytes->mempos = 0;
	pBytes->memlen = 256;
	pBytes->mem=ckalloc(pBytes->memlen);
}

void	DynBytes_Finish(pDynBytes_t pBytes)
{
	pBytes->mem = ckrealloc(pBytes->mem,pBytes->mempos);
}

void	DynBytes_Append( pDynBytes_t pBytes, size_t len, void* adr )
{
	DynBytes_Extend( pBytes, len );
	memcpy((char*)pBytes->mem+pBytes->mempos,adr,len);
	pBytes->mempos += len;
}

void	DynBytes_Align( pDynBytes_t pBytes )
{
	size_t	n = ((pBytes->mempos+3)&0xffffffc)-pBytes->mempos;
	if(n){
		int	z = 0;
		DynBytes_Append(pBytes,n,&z);
		}
}

static	void	outCode(pDynBytes_t pBytes, size_t n,...)
{
	va_list	arg;
	unsigned char* p;
	DynBytes_Extend(pBytes,n);
	p = (unsigned char*)(pBytes->mem)+pBytes->mempos;
	pBytes->mempos += n;
	va_start(arg,n);
	while(n--) *p++ = va_arg(arg,unsigned);
	va_end(arg);
}

#if	0
typedef struct	{
				size_t	mFill;
				size_t	nFill;
				struct	{
					unsigned	offs;		/*code relative offset*/
					unsigned	value;
					} Fill[1];
				} Fillin_t, *pFillin_t;

pFillin_t	Fillin_Add( pFillin_t pF, unsigned offs, unsigned value )
{
	if(pF->nFill==pF->mFill){
		pF->mFill <<= 1;
		pF = (pFillin_t)ckrealloc(pF,sizeof(*pF)+(pF->mFill)*sizeof(pF->Fill[0]));
		}
	pF->Fill[pF->nFill].offs = offs;
	pF->Fill[pF->nFill++].value = value;
	return pF;
}
#endif

char*	Generate_Callback(pCBD_t pCBD, void* adr)
{
	pCBAD_t		pCBAD = pCBD->cb_argdef;
	DynBytes_t	Code;
	size_t		esp = 0, argoffs = 0, esp0;
	size_t		targlen = pCBAD->targlen;
	pCBA_t		argdef = pCBAD->argdef;
	size_t		j, k;
	char		ret_type = argdef[0].argtype;
	size_t		ret_len = argdef[0].arglen;
	size_t		pos_1, pos_2, movlea;

	DynBytes_Init(&Code);


	/*allocate some space on the stack if needed for the return value*/
	if(ret_type!='v' && ret_len<=8){
		/*sub exp 0x10*/
		outCode(&Code,3,0x83,0xec,0x10);
		esp += 0x10;
		/*lea, edx dword ptr [esp]*/
		outCode(&Code,4,0x8d,0x54,0x24,0x00);
		}
	else if(ret_len>8){
		/*lea, edx dword ptr [esp+4]*/
		outCode(&Code,4,0x8d,0x54,0x24,0x04);
		argoffs = 4;
		}
	esp0 = esp;
	for(pos_2=argoffs+targlen,j=pCBAD->nargs-1;j>=1;j--){
		movlea = argdef[j].argtype=='s' ? 0x8b : 0x8d;
		k = argdef[j].arglen;
		k = ((k+3)>>2)<<2;
		if((pos_1=pos_2+esp-k+4)<=127){
			/*lea/mov eax,[esp+byte] == 8d 44 24*/
			outCode(&Code,4,movlea,0x44,0x24,pos_1);
			}
		else {
			/*lea/mov eax,[esp+long] == 8d 84 24*/
			outCode(&Code,7,movlea,0x84,0x24,
					pos_1&0xff,(pos_1>>8)&0xff,(pos_1>>16)&0xff,(pos_1>>24)&0xff);
			}
		/*push eax*/
		outCode(&Code,1,0x50);
		pos_2 -= k;
		esp += 4;
		}

	if(ret_type!='v'){
		/*push edx*/
		outCode(&Code,1,0x52);
		}
	else {
		/*push 0*/
		outCode(&Code,2,0x6A,0x0);
		}
	esp += 4;
	
	/*push 0x12345678*/
	pos_1 = Code.mempos+1;
	outCode(&Code,5,0x68,0x78,0x56,0x34,0x12);
	esp += 4;
	pos_2 = Code.mempos+1;
	/*move eax, 0x12345678*/
	outCode(&Code,5,0xB8,0x78,0x56,0x34,0x12);
	/*call eax*/
	outCode(&Code,2,0xff,0xd0);

	/*eliminate pushed arguments*/
	k = esp - esp0;
	if(k<256){
		outCode(&Code,3,0x83,0xc4,k);
		}
	else {
		outCode(&Code,6,0x81,0xc4,k&0xff, (k>>8)&0xff, (k>>16)&0xff, (k>>24)&0xff);
		}

	if(ret_type!='v' && ret_len<=8){
		if(ret_type=='d'||ret_type=='f'){
			/*fld qword ptr [esp]*/
			outCode(&Code,4,0xdd,0x44,0x24,0x00);
			}
		else {
			if(ret_len>4){
				/*mov ecx, dword ptr [esp+4]*/
				outCode(&Code,4,0x8b,0x4c,0x24,0x04);
				}
			/*mov eax, dword ptr [esp]*/
			outCode(&Code,4,0x8b,0x44,0x24,0x00);
			}

		/*eliminate space for the return value*/
		outCode(&Code,3,0x83,0xc4,0x10);
		}
	if(pCBD->cb_stdcall){
		k = targlen + argoffs;
		/*ret targlen+argoffs*/
		outCode(&Code,2,0xc2,k);
		}
	else {
		/*ret*/
		outCode(&Code,1,0xc3);
		}
	DynBytes_Finish(&Code);

	/*patch in the standard addresses*/
	memcpy((unsigned char*)Code.mem+pos_1,&pCBD,4);
	memcpy((unsigned char*)Code.mem+pos_2,&adr,4);

	return Code.mem;
}

char*	Generate_Argdef(pCBA_t pCBA, char* buf)
{
	buf[0] = pCBA->argtype;
	if(buf[0]=='b') sprintf(buf+1,"%d",pCBA->arglen);
	else buf[1] = 0;
	return buf;
}
