namespace eval ::dll {
	namespace export define
	proc define {name path rtn retdef args} {
		if {![regexp "^(\[vifd\]|(0-9)+)\$" $retdef]} {
			error "bad return definition '$retdef'"
			}
		set voidret [regexp "^(v|0+)\$" $retdef]
		set i 0
		set argstr \{
		set argdef ""
		set header ""
		foreach a $args {
			regexp "^(\[^=\]+)(=|)(.*)" $a {} k {} v
			switch -exact -regexp $k {
				\\*s*[0-9]+ {
					if {$v=={}} {
						set v "s$i"
						append header "upvar \$a$i \{$v\}\n"
						} \
					else {
						append header "upvar \{$v\} s$i\n"
						set v "s$i"
						}
					}
				i	-
				f	-
				d	-
				b	-
				s	-
				@	{
					}
				default {
					error "bad argument definition '$a'"
					}
				}
			if {$v=={}} {
				append argstr " a$i"
				append argdef " \[list $k \$a$i\]"
				} \
			else {
				append argdef " {$k \{$v\}}"
				}
			incr i
			}
		append argstr \}
		set p "::dll::call [makeAbsPath $path] $rtn $retdef $argdef"
		if {!$voidret} {
			set p "return \[$p\]\}"
			} \
		else {
			set p "$p;return \{\}\}"
			}
		uplevel proc $name $argstr "\{${header}$p"
		return $name
		}

	proc makeAbsPath {path} {
		switch -exact [file pathtype $path] {
			absolute {
				return $path
				}
			relative {
				return [file join [pwd] $path]
				}
			volumerelative {
				set splitpath [file split $path]
				set volume [lindex $splitpath 0]
				set cwd [pwd]
				cd $volume
			    eval set abspath \[file join [pwd] [lrange $splitpath 1 end]\]
				cd $cwd
				return $abspath
				}
			}
		}
	}
