package require dll
namespace eval ::dll::win32 {
	namespace export FlashWindow GetWindowText
	variable WA
	set WA A
	proc GetWindowText {hWnd} {
		set r [::dll::call user32.dll GetWindowTextA i [list i $hWnd] {*s256 text} {i 255}]
		return "$text"
		}
	proc EnumWindows {} {
		proc EnumWCB {i s} {
			upvar 1 $s L
			lappend L 0x[format %x $i]
			return 1
			}
		::dll::callback cdecl EnumWCB EnumWCB i i s
		set WindowList {}
		::dll::call user32.dll EnumWindows i {@ EnumWCB} {s WindowList}
		rename EnumWCB {}
		::dll::callback delete EnumWCB
		return $WindowList
		}

	proc GetTitledWindows {} {
		set r {}
		foreach w [EnumWindows] {
			set t [string trim [GetWindowText $w]]
			if {[string length $t]} {
				lappend r [list $w $t]
				}
			}
		return $r
		}

	#find window handle based on class and title
	::dll::define FindWindow user32.dll FindWindow$::dll::WA i s s

#forground
proc GetForegroundWindow {} {
	return [::dll::call user32.dll GetForegroundWindow i]
	}

#force to forground
proc SetForegroundWindow {hWnd} {
	return [::dll::call user32.dll SetForegroundWindow i [list i $hWnd]]
	}

#Set Window Text
proc SetWindowText {hWnd Text} {
	return [::dll::call user32.dll SetWindowTextA i [list i $hWnd] [list s $Text]]
	}

#Is it a window
proc IsWindow {hWnd} {
	return [::dll::call user32.dll IsWindow i [list i $hWnd]]
	}

#Is window zoomed
proc IsZoomed {hWnd} {
	return [::dll::call user32.dll IsZoomed i [list i $hWnd]]
	}

#Is window enabled
proc IsWindowEnabled {hWnd} {
	return [::dll::call user32.dll IsWindowEnabled i [list i $hWnd]]
	}

#enable window true/false
proc EnableWindow {hWnd flag} {
	if {$flag} {set flag 1} else {set flag 0}
	return [::dll::call user32.dll EnableWindow i [list i $hWnd] [list i $flag]]
	}

#Is window visible
proc IsWindowVisible {hWnd} {
	return [::dll::call user32.dll IsWindowVisible i [list i $hWnd]]
	}

#Is window iconised
proc IsIconic {hWnd} {
	return [::dll::call user32.dll IsIconic i [list i $hWnd]]
	}

#iconize
proc CloseWindow {hWnd} {
	return [::dll::call user32.dll CloseWindow i [list i $hWnd]]
	}

#restore
proc OpenIcon {hWnd} {
	return [::dll::call user32.dll OpenIcon i [list i $hWnd]]
	}

	proc LoadLibrary {path} {
		return [::dll::call kernel32.dll LoadLibraryA i [list s $path]]
		}

	proc FreeLibrary {hLibModule} {
		return [::dll::call kernel32.dll FreeLibrary i [list i $hLibModule]]
		}
	proc FlashWindow {hWnd {count 20} {d 400}} {
		set state [expr {$count>0}]
		::dll::call user32.dll FlashWindow i [list i $hWnd] [list i $state]
		if {$state} {
			incr count -1
			after $d [list ::dll::win32::FlashWindow $hWnd $count $d]
			}
		}
	package provide ::dll::win32 0.0.0.0
	}
