#include <stdarg.h>
#include "tclInt.h"
#include "tclPort.h"
#include "generate.h"

static	void __stdcall FuncUsageError(Tcl_Interp* interp, Tcl_Obj*CONST objv[])
{
	Tcl_AppendResult(interp,Tcl_GetStringFromObj(objv[0],NULL)," usage error",NULL);
}

static	void __stdcall FuncDecrObj(Tcl_Obj* Obj[],Tcl_Obj* CONST objv[])
{
	int	i;
	for(i=1;i<=(int)Obj[0];i++){
		if(Obj[i]!=objv[i]){
			Tcl_DecrRefCount(Obj[i]);
			}
		}
}

static	void __stdcall FuncGetObj( Tcl_Obj* CONST objv[], Tcl_Obj* Obj[], int i)
{
	if(i==1) Obj[0] = (Tcl_Obj*)1;
	else {
		Obj[0] = (Tcl_Obj*)(((int)Obj[0]) + 1);
		}
	Obj[i] = objv[i];
	if(Tcl_IsShared(Obj[i])) Obj[i] = Tcl_DuplicateObj(Obj[i]);
}

static	int __stdcall FuncGetIntObj( Tcl_Interp* interp, Tcl_Obj* CONST objv[], Tcl_Obj* Obj[], int i, int* iv )
{
	FuncGetObj(objv,Obj,i);
	return Tcl_GetIntFromObj(interp,Obj[i],iv);
}

static	void __stdcall FuncIntResult( Tcl_Interp* interp, int i)
{
	Tcl_SetObjResult(interp,Tcl_NewIntObj(i));
}

static	void __stdcall FuncDoubleResult( Tcl_Interp* interp, double i)
{
	Tcl_SetObjResult(interp,Tcl_NewDoubleObj(i));
}

static	void __stdcall FuncFloatResult( Tcl_Interp* interp, float i)
{
	Tcl_SetObjResult(interp,Tcl_NewDoubleObj((double)i));
}

int power2( int num, int power )
{
   __asm
   {
      mov eax, num    ; Get first argument
      mov ecx, power  ; Get second argument
      shl eax, cl     ; EAX = EAX * ( 2 to the power of CL )
	  sub esp, eax
	  add esp, eax
	  	push 127
		push 128
  		lea	eax, [esp+124]
  		lea	eax, [esp+128]
  		lea	eax, [esp-124]
  		lea	eax, [esp-128]
   }
}

static	int	FuncInit(pDFunc_t pDFunc, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[] )
{
	Tcl_ResetResult(interp);
	if(objc!=2){
		FuncUsageError(interp,objv);
		return TCL_ERROR;
		}
	return TCL_OK;
}
int FuncGetArgs( pDFunc_t pDFunc, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[], char* stack )
{
	return TCL_OK;
}

int Declared_IntProc( pDFunc_t pDFunc, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[] )
{
	typedef int (*pif_t)(void);
	if(FuncInit(pDFunc, interp, objc, objv)!=TCL_OK) return TCL_ERROR;
	{
	char*	stack = alloca(pDFunc->TotalArgLen);
	FuncGetArgs(pDFunc, interp, objc, objv, stack);
	Tcl_SetObjResult(interp,Tcl_NewIntObj(((pif_t)(pDFunc->adr))()));
	}
	return TCL_OK;
}

int vfunc(int i1, int i2, int i3, int i4, int i5, int i6, int i7, int i8, int i9, int i10){return 0;}
int int2str_proc( ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[] )
{
	int			result;
	Tcl_Obj*	Obj[11];
	int			i[10];

	Tcl_ResetResult(interp);
	if(objc!=2){
		FuncUsageError(interp,objv);
		return TCL_ERROR;
		}
	if(FuncGetIntObj(interp,objv,Obj, 1, i)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 2, i+1)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 3, i+2)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 4, i+3)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 5, i+4)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 6, i+5)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 7, i+6)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 8, i+7)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 9, i+8)) goto X0;
	if(FuncGetIntObj(interp,objv,Obj, 10, i+9)) goto X0;
	result = vfunc(i[0],i[1],i[2],i[3],i[4],i[5],i[6],i[7],i[8],i[9]);
X0:
	FuncDecrObj(Obj,objv);
	return result;
}
